package cokr.xit.fims.mngt.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.fims.cmmn.CmmnQuery;
import cokr.xit.fims.mngt.Task;
import cokr.xit.fims.mngt.dao.TaskMapper;
import cokr.xit.foundation.component.AbstractBean;
import cokr.xit.foundation.data.DataObject;

/**업무 정보 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-10-24	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("taskBean")
public class TaskBean extends AbstractBean {
	/** 업무 정보 정보 DAO */
	@Resource(name = "taskMapper")
	private TaskMapper taskMapper;

	/**지정한 조건에 따라 업무 정보 목록을 조회하여 반환한다.
	 * @param req 업무 정보 조회 조건
	 * @return 업무 정보 목록
	 */
	public List<DataObject> getTaskList(CmmnQuery req) {
		return taskMapper.selectTaskList(req);
	}

	/**지정한 조건에 따라 업무 객체들을 반환한다.
	 * @param req 업무 조회 조건
	 * @return 업무 객체 목록
	 */
	public List<DataObject> getTasks(CmmnQuery req) {
		return taskMapper.selectTasks(req);
	}

	/**지정한 조건에 따라 업무 정보 객체를 반환한다.
	 * @param req 위반 정보 조회 조건
	 * @return 위반 정보 객체 목록
	 */
	public DataObject getTaskInfo(CmmnQuery req) {
		return taskMapper.selectTaskInfo(req);
	}

	/**지정한 조건에 따라 사전통지 일자를 반환한다.
	 * @param req 위반 정보 조회 조건
	 * @return 위반 정보 객체 목록
	 */
	public DataObject getAdvntceYmdInfo(CmmnQuery req) {
		return taskMapper.selectAdvntceYmdInfo(req);
	}

	/**업무 정보 정보를 등록한다.
	 * @param taskInfo 업무 정보
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean create(Task task) {
		return taskMapper.insert(task);
	}

	/**업무 정보 정보를 수정한다.
	 * @param taskInfo 업무 정보
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean update(Task task) {
		return taskMapper.update(task);
	}

	/**업무 정보 정보를 삭제한다.
	 * @param taskInfo 업무 정보
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean remove(Task task) {
		return taskMapper.delete(task);
	}
}